#Created by: Melissa Trayhan, Rochester Center For Health Informatics
#This file reads in claims data and pulls out selected columns to create a smaller file

#!/usr/bin/perl
use strict;
use warnings;

my $file;     #this will store the name of the claims file
my $result_file;      #this will be the filename for the result file with only certain columns from the original claims file
my $correct = "N";    #used for verifying information entered is correct
my $patientid;      #number for column in claims file that holds the patient or beneficary id
my $startid;        #number for column in claims file that holds the start date for the claim
my $orgnpi;         #number for column in claims file that holds the organization id
my $attnpi;         #number for column in claims file that holds the attedning provider id
my $oprnpi;         #number for column in claims file that holds the operating provider id
 

while ($correct eq "N" || $correct eq "n") {     #ask the user for the column numbers for the columns we are selecting
  print "Name of the claims file: ";
  $file = <>;
  chomp $file;
  print "Name for the results file: ";
  $result_file = <>;
  chomp $result_file;
  print "What column contains the beneficiary id: ";
  $patientid = <>;
  chomp $patientid;
  print "What column contains the start date: ";
  $startid = <>;
  chomp $startid;
  print "What column contains the organization npi: ";
  $orgnpi = <>;
  chomp $orgnpi;
  print "What column contains the attending npi: ";
  $attnpi = <>;
  chomp $attnpi;
  print "What column contains the operating npi: ";
  $oprnpi = <>;
  chomp $oprnpi;
  print "\nAre these columns correct?
Beneficiary id: $patientid, Start date: $startid, Organization NPI: $orgnpi, Attending NPI: $attnpi, Operating NPI: $oprnpi
Type Y for yes or N for no: ";
  $correct = <>;
  chomp $correct;
  unless (-f $file) {
    print "Not a valid file! Try again\n";
    $correct = "N";
  }
}    #if user made an error, ask for the columns again, else exit loop

#open claims file and results file
open(my $data, '<', $file) or die "Could not open '$file' $!\n";
open(my $fh, '>', $result_file) or die "Could not open results file, $!\n";

#print selected columns to the new results file
while (my $line = <$data> ) {
  chomp $line;
  my @fields = split "," , $line;
  print $fh "$fields[$patientid-1],$fields[$startid-1],$fields[$orgnpi-1],$fields[$attnpi-1],$fields[$oprnpi-1]\n";
}


close $data;
close $fh;
